Attribute VB_Name = "modDFUE"
' Modulname : vbzDFUE.bas
' Version   : 1.0
' Stand     : 12.09.2004
' Quelle    : http://www.vb-zentrum.de
' Anmerkung : bentigt vbzGlobal.bas

Option Explicit

' Konstanten:
Public Const DIAL_UNATTENDED = &H8000
Public Const DIAL_FORCE_ONLINE = 1
Public Const DIAL_FORCE_UNATTENDED = 2

Public Const RAS_MaxEntryName = 256
Public Const RAS_MaxDeviceType = 16
Public Const RAS_MaxDeviceName = 128

' Typendefinitionen:
Type RASENTRYNAME
  dwSize As Long
  szEntryName(RAS_MaxEntryName) As Byte
End Type

Type RASType
  dwSize As Long
  hRasCon As Long
  szEntryName(RAS_MaxEntryName) As Byte
  szDeviceType(RAS_MaxDeviceType) As Byte
  szDeviceName(RAS_MaxDeviceName) As Byte
End Type

Type RASStatusType
  dwSize As Long
  RasConnState As Long
  dwError As Long
  szDeviceType(RAS_MaxDeviceType) As Byte
  szDeviceName(RAS_MaxDeviceName) As Byte
End Type

' Funktionsdeklarationen:
Private Declare Function InternetDial Lib "wininet.dll" (ByVal hwndParent As Long, ByVal lpszConiID _
        As String, ByVal dwFlags As Long, ByRef hCon As Long, ByVal dwReserved As Long) As Long
Private Declare Function InternetHangUp Lib "wininet.dll" (ByVal hCon As Long, ByVal dwReserved As Long) As Long
Private Declare Function RasEnumEntries Lib "RasApi32.dll" _
        Alias "RasEnumEntriesA" (ByVal reserved As String, ByVal lpszPhonebook As String, _
        lprasentryname As Any, lpcb As Long, lpcEntries As Long) As Long
Private Declare Function RasEnumConnections Lib "RasApi32.dll" _
        Alias "RasEnumConnectionsA" (lpRasCon As Any, lpcb As Long, lpcConnections As Long) As Long
Private Declare Function RasGetConnectStatus Lib "RasApi32.dll" _
        Alias "RasGetConnectStatusA" (ByVal hRasCon As Long, lpStatus As Any) As Long

' Variabeln:
Public ConID As Long            ' Verbindungs-Index fr ConName
Public ConName(10) As String    ' Namen der konfigurierten DF-Verbindungen

' init_dfue:
' muss bei Programmstart in 'Sub Main' oder 'Sub Form_Load' der Startform
' aufgerufen werden!
Public Sub init_dfue()
  Dim i As Long
  Dim s As Long, ln As Long
  Dim entry As String
  Dim R(255) As RASENTRYNAME
    
  ' Namen der bestehenden DF-Verbindungen einlesen
  R(0).dwSize = 264
  s = 256 * R(0).dwSize
  RasEnumEntries vbNullString, vbNullString, R(0), s, ln
    
  If ln > 0 Then
    For i = 0 To ln - 1
      If i > UBound(ConName) Then Exit For
      entry = StrConv(R(i).szEntryName(), vbUnicode)
      ConName(i) = nullTrim(entry)
    Next i
  Else
    ConName(0) = "nicht verfgbar"
  End If
End Sub

' dfue_connect: startet den Dialog zum Verbindungsaufbau
' Wertbergabe frm  : aktuelle Form, die die Prozedur aufruft
' Wertbergabe index: Index der gewnschten DF-Verbindung, wenn
'                     mehrere Verbindungen existieren. Wird Index
'                     nicht angegeben, so wird die erste Verbindung
'                     (Index=0) angenommen.
Public Sub dfue_connect(ByVal frm As Form, Optional ByVal index As Integer = 0)
  InternetDial frm.hwnd, asString(ConName(index)), DIAL_FORCE_ONLINE, ConID, 0
End Sub

' dfue_hangup: Trennt eine bestehende Verbindung:
Public Sub dfue_hangup()
  If ConID <> 0 Then InternetHangUp ConID, 0
  ConID = 0
End Sub

' dfue_status:
' Gibt den Status der Verbindung als Klartext im String 'status'
' zurck. Rckgabewert: True, wenn Verbindung 'Online', sonst False
Public Function dfue_status(ByRef status As String) As Boolean
  Dim lg As Long, lpcon As Long, ret As Long
  Dim RAS(255) As RASType
  Dim RASStatus As RASStatusType

  RAS(0).dwSize = 412
  lg = 256 * RAS(0).dwSize
  ret = RasEnumConnections(RAS(0), lg, lpcon)
    
  If lpcon = 0 Then
    status = "Offline"
  Else
    RASStatus.dwSize = 160
    ret = RasGetConnectStatus(RAS(0).hRasCon, RASStatus)
    If RASStatus.RasConnState = &H2000 Then
      status = "Online"
    Else
      status = "Verbindungsaufbau"
    End If
  End If
  dfue_status = (status = "Online")
End Function

